#!/usr/bin/env python
# -*- coding: utf-8 -*-
from __main__ import *

def shapeCross(x1,x2,y1,y2,v1,v2,v3,v4,v5,v6):
	an, al=(x2 - x1, y2 - y1)
	an2=an/2
	al2=al/2
	name=_('cross')
	crW = v2
	rad = v1
	crw2 = crW/2
	corners = v6
	pX = [x1+an2-crw2, x1+an2+crw2]
	pY = [y1+al2-crw2, y1+al2+crw2]
	pts=[[pX[0],y1], [pX[1],y1], [pX[1],pY[0]], [x2, pY[0]], [x2, pY[1]], [pX[1],pY[1]],
		[pX[1],y2], [pX[0],y2], [pX[0],pY[1]], [x1,pY[1]], [x1,pY[0]], [pX[0],pY[0]]]
	bezs=[bezpnt(p) for p in pts]
	# chamfer
	if rad>0:
		r2=rad*varBez
		if corners==2:
			name+=_('Chamfer')
			pts=[[pX[0]+rad,y1], [pX[1]-rad, y1], [pX[1], y1+rad], [pX[1], pY[0]], [x2-rad,pY[0]],
				[x2,pY[0]+rad],  [x2,pY[1]-rad],  [x2-rad,pY[1]],  [pX[1], pY[1]], [pX[1], y2-rad],
				[pX[1]-rad, y2], [pX[0]+rad, y2], [pX[0], y2-rad], [pX[0], pY[1]], [x1+rad,pY[1]],
				[x1,pY[1]-rad],  [x1,pY[0]+rad],  [x1+rad,pY[0]],  [pX[0], pY[0]], [pX[0], y1+rad]]
			bezs=[bezpnt(p) for p in pts]
		elif corners==0:
			name=name+_('Rounded')
			bezs=[
				bezpnt([pX[0]+rad,y1],[pX[0]+r2,y1]),         bezpnt([pX[1]-rad,y1],None,[pX[1]-r2, y1]),
				bezpnt([pX[1],y1+rad],[pX[1],y1+rad-r2]),     bezpnt([pX[1],pY[0]]),
				bezpnt([x2-rad,pY[0]],None,[x2-rad+r2,pY[0]]),bezpnt([x2,pY[0]+rad],[x2,pY[0]+rad-r2]),
				bezpnt([x2,pY[1]-rad],None,[x2,pY[1]-rad+r2]),bezpnt([x2-rad,pY[1]],[x2-rad+r2,pY[1]]),
				bezpnt([pX[1],pY[1]]),                        bezpnt([pX[1],y2-rad],None,[pX[1], y2-rad+r2]),
				bezpnt([pX[1]-rad,y2],[pX[1]-rad+r2, y2]),    bezpnt([pX[0]+rad, y2],None,[pX[0]+rad-r2, y2]),
				bezpnt([pX[0],y2-rad],[pX[0],y2-rad+r2]),     bezpnt([pX[0],pY[1]]),  
				bezpnt([x1+rad,pY[1]],None,[x1+rad-r2,pY[1]]),bezpnt([x1,pY[1]-rad],[x1,pY[1]-rad+r2]),
				bezpnt([x1,pY[0]+rad],None,[x1,pY[0]+rad-r2]),bezpnt([x1+rad,pY[0]],[x1+rad-r2,pY[0]]),
				bezpnt([pX[0], pY[0]]),                       bezpnt([pX[0], y1+rad],None,[pX[0], y1+rad-r2])]
		elif corners==1:
			name=name+_('RoundedInv')
			bezs=[
				bezpnt([pX[0]+rad,y1],[pX[0]+rad,y1+r2]),      bezpnt([pX[1]-rad,y1],None,[pX[1]-rad,y1+r2]),
				bezpnt([pX[1],y1+rad],[pX[1]-r2, y1+rad]),     bezpnt([pX[1],pY[0]]),
				bezpnt([x2-rad,pY[0]],None,[x2-rad,pY[0]+r2]), bezpnt([x2,pY[0]+rad],[x2-r2,pY[0]+rad]),
				bezpnt([x2,pY[1]-rad],None,[x2-r2,pY[1]-rad]), bezpnt([x2-rad,pY[1]],[x2-rad,pY[1]-r2]),
				bezpnt([pX[1],pY[1]]),                         bezpnt([pX[1],y2-rad],None,[pX[1]-r2,y2-rad]),
				bezpnt([pX[1]-rad, y2],[pX[1]-rad, y2-r2]),    bezpnt([pX[0]+rad,y2],None,[pX[0]+rad,y2-r2]),
				bezpnt([pX[0], y2-rad],[pX[0]+r2, y2-rad]),    bezpnt([pX[0], pY[1]]),
				bezpnt([x1+rad,pY[1]],None,[x1+rad,pY[1]-r2]), bezpnt([x1,pY[1]-rad],[x1+r2,pY[1]-rad]),
				bezpnt([x1,pY[0]+rad],None,[x1+r2,pY[0]+rad]), bezpnt([x1+rad,pY[0]],[x1+rad,pY[0]+r2]),
				bezpnt([pX[0], pY[0]]),                        bezpnt([pX[0], y1+rad],None,[pX[0]+r2, y1+rad])
			]
	return [name,bezs,_('Max. roundness:'),crw2,True]

SHAPES2['cross']={'tit':_('Krzyż'),'def':shapeCross,'labels':[_("Krągłość:      "),[_("Grubość:"),1.0],"-",_("Narożniki:"),"-",CORNERS]}

