#!/usr/bin/env python
# -*- coding: utf-8 -*-
from __main__ import *

def shapeRomb(x1,x2,y1,y2, rad,v2,v3,v4,v5,v6):
	corners=v6
	name=_('rhomboid')
	an, al=(x2 - x1, y2 - y1)
	an2, al2=(an/2,al/2)
	la = min(an,al)
	rad2=rad/2.0
	ll=math.sqrt(math.pow(an2,2)+math.pow(al2,2))*4  #sideLength
	mrad=(an*al)/ll
	if rad==0:
		bezs=[bezpnt(p) for p in [[x1+an2,y1], [x1,y1+al2], [x1+an2,y2], [x2,y1+al2]]]
	# chamfer
	else:
		if corners==1:
			name+=_('Chamfer')
			bezs=[bezpnt(p) for p in [[x1+an2-rad2,y1], [x1+an2+rad2,y1], [x2,y1+al2-rad2], [x2,y1+al2+rad2], [x1+an2+rad2,y2], [x1+an2-rad2,y2], [x1,y1+al2+rad2], [x1,y1+al2-rad2]]]
		elif corners==0:
			name+=_('Rounded')
			bezs=[]
			arc1=arcLinesBez(pnt2d(0,an2),pnt2d(-al2,0),pnt2d(al2,0),rad)
			arc2=arcLinesBez(pnt2d(0,al2),pnt2d(-an2,0),pnt2d(an2,0),rad)
			bezs.extend(rotArcBez(arc1,90)+rotArcBez(arc2,0)+rotArcBez(arc1,270)+rotArcBez(arc2,180))
			for bez in bezs: bez.translate(x1+an/2.0, y1+al/2.0)
	return [name,bezs,_('Max. roundness:'),mrad,True]

SHAPES2['romb']={'tit':_('Romb'),'def':shapeRomb,'labels':[_("Krągłość:	 "),"-","-",_("Narożniki:"),"-",CORNERSROMB]}
